polylib: Zpolyhedron.h File Reference

# Zpolyhedron.h File Reference

Go to the source code of this file.

## Functions
void | CanonicalForm (ZPolyhedron *Zpol, ZPolyhedron **Result, Matrix **Basis)
ZPolyhedron * | EmptyZPolyhedron (int dimension)
ZPolyhedron * | IntegraliseLattice (ZPolyhedron *A)
Bool | isEmptyZPolyhedron (ZPolyhedron *Zpol)
ZPolyhedron * | ZDomainDifference (ZPolyhedron *A, ZPolyhedron *B)
ZPolyhedron * | ZDomainImage (ZPolyhedron *A, Matrix *Func)
Bool | ZDomainIncludes (ZPolyhedron *A, ZPolyhedron *B)
ZPolyhedron * | ZDomainIntersection (ZPolyhedron *A, ZPolyhedron *B)
ZPolyhedron * | ZDomainPreimage (ZPolyhedron *A, Matrix *Func)
void | ZDomainPrint (FILE *fp, const char *format, ZPolyhedron *A)
ZPolyhedron * | ZDomainSimplify (ZPolyhedron *ZDom)
ZPolyhedron * | ZDomainUnion (ZPolyhedron *A, ZPolyhedron *B)
ZPolyhedron * | ZDomain_Copy (ZPolyhedron *Head)
void | ZDomain_Free (ZPolyhedron *Head)
Bool | ZPolyhedronIncludes (ZPolyhedron *A, ZPolyhedron *B)
ZPolyhedron * | ZPolyhedron_Alloc (Lattice *Lat, Polyhedron *Poly)
ZPolyhedron * | SplitZpolyhedron (ZPolyhedron *ZPol, Lattice *B)

## Function Documentation

void CanonicalForm | ( | ZPolyhedron * | Zpol,
|  | ZPolyhedron ** | Result,
|  | Matrix ** | Basis |
| ) |  |  |

Definition at line 761 of file Zpolyhedron.c.

References AffineHermite(), ChangeLatticeDimension(), Domain_Free(), DomainImage(), FindHermiteBasisofDomain(), Identity(), isEmptyZPolyhedron(), ZPolyhedron::Lat, Matrix_Alloc(), Matrix_Copy(), Matrix_Free(), Matrix_Inverse(), Matrix_Product(), MAXNOOFRAYS, matrix::NbColumns, matrix::NbRows, matrix::p, ZPolyhedron::P, Polyhedron_Free(), value_assign, value_clear, value_init, ZDomain_Copy(), and ZPolyhedron_Alloc().

Referenced by AddZPolytoZDomain(), and main().

ZPolyhedron* EmptyZPolyhedron | ( | int | dimension | ) |

Definition at line 264 of file Zpolyhedron.c.

References Domain_Free(), Empty_Polyhedron(), EmptyLattice(), Matrix_Free(), and ZPolyhedron_Alloc().

Referenced by IntegraliseLattice(), main(), ZDomainDifference(), ZDomainImage(), ZDomainIntersection(), ZDomainPreimage(), ZDomainSimplify(), ZPolyhedronDifference(), ZPolyhedronIntersection(), and ZPolyhedronPreimage().

ZPolyhedron* IntegraliseLattice | ( | ZPolyhedron * | A | ) |

Definition at line 854 of file Zpolyhedron.c.

References Domain_Free(), DomainImage(), DomainPreimage(), EmptyZPolyhedron(), Identity(), isEmptyLattice(), ZPolyhedron::Lat, LatticeImage(), Matrix_Free(), MAXNOOFRAYS, matrix::NbRows, ZPolyhedron::P, and ZPolyhedron_Alloc().

Referenced by ZPolyhedron_Alloc().

Bool isEmptyZPolyhedron | ( | ZPolyhedron * | Zpol | ) |

Definition at line 40 of file Zpolyhedron.c.

References emptyQ, False, isEmptyLattice(), ZPolyhedron::Lat, ZPolyhedron::P, and True.

Referenced by AddZPoly2ZDomain(), AddZPolytoZDomain(), CanonicalForm(), main(), ZDomainIncludes(), and ZPolyhedronDifference().

ZPolyhedron* SplitZpolyhedron | ( | ZPolyhedron * | ZPol,
|  | Lattice * | B |
| ) |  |  |

Definition at line 971 of file Zpolyhedron.c.

References AddZPoly2ZDomain(), AffineHermite(), isEmptyLattice(), isinHnf(), ZPolyhedron::Lat, Lattice2LatticeUnion(), Matrix_Copy(), Matrix_Free(), matrix::NbColumns, matrix::NbRows, LatticeUnion::next, ZPolyhedron::P, True, ZPolyhedron_Alloc(), and ZPolyhedron_Free().

Referenced by main().

ZPolyhedron* ZDomain_Copy | ( | ZPolyhedron * | Head | ) |

Definition at line 118 of file Zpolyhedron.c.

References ZPolyhedron::next, ZDomain_Copy(), and ZPolyhedron_Copy().

Referenced by CanonicalForm(), ZDomain_Copy(), and ZPolyhedronDifference().

void ZDomain_Free | ( | ZPolyhedron * | Head | ) |

Definition at line 93 of file Zpolyhedron.c.

References ZPolyhedron::next, ZDomain_Free(), and ZPolyhedron_Free().

Referenced by AddZPoly2ZDomain(), AddZPolytoZDomain(), main(), ZDomain_Free(), ZDomainDifference(), and ZDomainIncludes().

ZPolyhedron* ZDomainDifference | ( | ZPolyhedron * | A,
|  | ZPolyhedron * | B |
| ) |  |  |

Definition at line 433 of file Zpolyhedron.c.

References AddZPoly2ZDomain(), AddZPolytoZDomain(), EmptyZPolyhedron(), ZPolyhedron::Lat, matrix::NbRows, ZPolyhedron::next, ZDomain_Free(), ZPolyhedron_Copy(), and ZPolyhedronDifference().

Referenced by main(), and ZDomainIncludes().

ZPolyhedron* ZDomainImage | ( | ZPolyhedron * | A,
|  | Matrix * | Func |
| ) |  |  |

Definition at line 486 of file Zpolyhedron.c.

References AddZPolytoZDomain(), EmptyZPolyhedron(), ZPolyhedron::Lat, matrix::NbRows, ZPolyhedron::next, ZPolyhedron_Free(), and ZPolyhedronImage().

Referenced by main().

Bool ZDomainIncludes | ( | ZPolyhedron * | A,
|  | ZPolyhedron * | B |
| ) |  |  |

Definition at line 289 of file Zpolyhedron.c.

References False, isEmptyZPolyhedron(), True, ZDomain_Free(), and ZDomainDifference().

ZPolyhedron* ZDomainIntersection | ( | ZPolyhedron * | A,
|  | ZPolyhedron * | B |
| ) |  |  |

Definition at line 396 of file Zpolyhedron.c.

References AddZPolytoZDomain(), EmptyZPolyhedron(), ZPolyhedron::Lat, matrix::NbRows, ZPolyhedron::next, ZPolyhedron_Free(), and ZPolyhedronIntersection().

Referenced by main().

ZPolyhedron* ZDomainPreimage | ( | ZPolyhedron * | A,
|  | Matrix * | Func |
| ) |  |  |

Definition at line 514 of file Zpolyhedron.c.

References AddZPolytoZDomain(), EmptyZPolyhedron(), ZPolyhedron::Lat, matrix::NbColumns, matrix::NbRows, ZPolyhedron::next, ZPolyhedron_Free(), and ZPolyhedronPreimage().

Referenced by main().

void ZDomainPrint | ( | FILE * | fp,
|  | const char * | format,
|  | ZPolyhedron * | A |
| ) |  |  |

Definition at line 338 of file Zpolyhedron.c.

References ZPolyhedron::next, ZDomainPrint(), and ZPolyhedronPrint().

Referenced by main(), and ZDomainPrint().

ZPolyhedron* ZDomainSimplify | ( | ZPolyhedron * | ZDom | ) |

Definition at line 887 of file Zpolyhedron.c.

References Domain_Copy(), Domain_Free(), DomainDifference(), DomainImage(), DomainPreimage(), emptyQ, EmptyZPolyhedron(), False, ZPolyhedron::Lat, LatticeSimplify(), LatticeUnion_Free(), forsimplify::LatUni, LatticeUnion::M, Matrix_Copy(), MAXNOOFRAYS, matrix::NbRows, LatticeUnion::next, forsimplify::next, ZPolyhedron::next, ZPolyhedron::P, forsimplify::Pol, True, ZDomainUnion(), ZPolyhedron_Alloc(), ZPolyhedron_Copy(), and ZPolyhedron_Free().

Referenced by main().

ZPolyhedron* ZDomainUnion | ( | ZPolyhedron * | A,
|  | ZPolyhedron * | B |
| ) |  |  |

Definition at line 374 of file Zpolyhedron.c.

References AddZPolytoZDomain(), and ZPolyhedron::next.

Referenced by main(), and ZDomainSimplify().

ZPolyhedron* ZPolyhedron_Alloc | ( | Lattice * | Lat,
|  | Polyhedron * | Poly |
| ) |  |  |

Definition at line 55 of file Zpolyhedron.c.

References polyhedron::Dimension, Domain_Copy(), False, IntegraliseLattice(), isEmptyLattice(), isfulldim(), IsLattice(), ZPolyhedron::Lat, Matrix_Copy(), matrix::NbRows, ZPolyhedron::next, ZPolyhedron::P, POL_ENSURE_FACETS, POL_ENSURE_VERTICES, and ZPolyhedron_Free().

Referenced by AddZPolytoZDomain(), CanonicalForm(), EmptyZPolyhedron(), IntegraliseLattice(), main(), SplitZpolyhedron(), ZDomainSimplify(), ZPolyhedron_Copy(), ZPolyhedronDifference(), ZPolyhedronImage(), ZPolyhedronIntersection(), and ZPolyhedronPreimage().

Bool ZPolyhedronIncludes | ( | ZPolyhedron * | A,
|  | ZPolyhedron * | B |
| ) |  |  |

Definition at line 306 of file Zpolyhedron.c.

References Domain_Free(), DomainDifference(), DomainImage(), emptyQ, False, ZPolyhedron::Lat, LatticeIncludes(), MAXNOOFRAYS, ZPolyhedron::P, and True.

Referenced by AddZPolytoZDomain(), and main().